#Jenny Chen
#CS206 Data Structures
#Text Adventure Game
#December 6, 2010

import time
import random

#global Backpack = []

class Time_Passed:
    def __init__(self, init_time):
        self.init_time = init_time

class Object:
    def __init__(self, location1, name, description):
        self.location1 = location1
        self.name = name
        self.description = description
        
class State:
    def __init__(self, name, description, constraint=None):
        self.name = name
        self.description = description
        self.edges = []

class Edge:
    def __init__(self, name, from_node, commands, to_node, 
                 description, health=None, constraints=None):
        self.name = name
        self.from_node = from_node 
        self.commands = commands
        self.to_node = to_node
        self.description = description
        #self.health = int(health)
        self.constraints = constraints

class Engine:
    def __init__(self, filename):
        self.filename = filename
        self.initial_state = None

    def load(self):
        self.states = {}
        self.edges = []
        self.objects=[]
        fp = open(self.filename)
        for line in fp:
            if len(line) == 0 or line[0] == '#':
                continue
            items = line.strip().split("::")
            if items[0] == 'node':
                s = State(*items[1:])
                if self.initial_state is None:
                    self.initial_state = s
                self.states[items[1]] = s
            elif items[0] == 'edge':
                self.edges.append(Edge(*items[1:]))
            elif items[0]=='object':
                self.objects.append(Object(*items[1:]))

        for edge in self.edges:
            self.states[edge.from_node].edges.append(edge)

    def play(self):
        current_state = self.initial_state
        objects_in_room = []

        init_time = time.time()
        current_time = time.time() - init_time

        print(current_time)

        print ("Please enter your name: ")
        player = input("Name> ")
        print("Hello,", player,"! Let us begin.")

        while True:
            #print ((time.time - init_time()),"seconds passed")
            for object in self.objects:
                if object.location1 == current_state.name:
                    objects_in_room.append(object)
                               
            print(current_state.description)
            command = input("Command> ")

            if command == "pick": #pick
                if len(objects_in_room) > 0:
                    objects_in_room[0].location1 = "backpack"
                    print ("You have picked up: ", objects_in_room[0].name)

            if command == "drop": #drop
                backpack_items = []
                for object in self.objects:
                    if object.location1 == "backpack":
                        backpack_items.append(object)
                        print ("You have this in your backpack:", object.name)
                if len(backpack_items) > 0:
                    backpack_items[0] = current_state.name
                    print ("You have dropped: ", object.name)
            else:
                for edge in current_state.edges:
                    if command in edge.commands:
                        current_state = self.states[edge.to_node]
                        break

            if command == "look": #look
                backpack = []
                if object.location1 == "backpack":
                    backpack_items.append(object)
                    print ("You have these items in your backpack: ", object.name)
                    prompt = input("What would you like to look at?")
                    if prompt == "hint1":
                        print("Hint1 says: You must go to the Graphics Lab. Remember to avoid the professors")
                    elif prompt == "hint2":
                        print("Hint2 says: Find Doug for the next clue. Remember to give him something in return")
                    elif prompt == "candy bar":
                        print("You are looking at a candy bar. Maybe a professor is hungry.")
                    elif prompt == "hint3":
                        print("Hint3 says: The Furby was last seen near the AI Lab.")
                    elif prompt == "Furby":
                        print("Looks like you've found the Furby. Bring it back to the Graphics Lab and drop it")
                else:
                    print("You do not have that item to look at.")
                    
##        def textwrap(text, col = 80):
##            retval = " "
##            count = 0
##            for c in text:
##                if count > col and C == " ":
##                    count = 0
##                else:
##                    retval += c
##                    count += 1
##            return retval

##    def end_game():
##        while True:
##            quit_qame = input("Do you really want to end this game? (yes/no)")
##            if quit_game == "yes":
##                print("Thanks for playing!")
##                quit
##            elif quit_game == "no":
##                print("Yay!")
##                game.load()
##            else:
##                end_game()
##
##    def play_again():
##        while True:
##            for obj in self.objects:
##                if obj.location == backpack and current_state == "Graphics Lab":
##                    print("You have won! All chaos has been restored! Bravo!")
##                    prompt = raw_input("Would you like to play again? (yes/no)")
##                    if prompt == "yes":
##                        game.load()
##                    else:
##                        quit
##            else:
##                print("Sorry, you have lost. Try again.")
##                prompt2 = input("Would you like to play again? (yes/no)")
##                if prompt2 == "yes":
##                    game.load()
##                else:
##                    quit
##

    
game = Engine("text_adventure.txt")
game.load()
game.play()
